<template>
  <div class="ele-body">
    <el-card shadow="never" v-loading="loading">
      <search-table @search="reload"></search-table>
      <!-- 数据表格 -->
      <ele-pro-table
        ref="table"
        :columns="columns"
        :datasource="datasource"
        height="calc(100vh - 325px)"
        full-height="calc(100vh - 116px)"
        tool-class="ele-toolbar-form"
        :selection.sync="selection"
        cache-key="eomContactPageTable">
        <!-- 表头工具栏 -->
        <template v-slot:toolbar>
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="handleAddOrEdit('','add')"
          >
            新建
          </el-button>
          <el-button
            size="small"
            type="danger"
            el-icon-delete
            class="ele-btn-icon"
            @click="allDelBtn"
            :disabled="selection?.length === 0"
          >
            批量删除
          </el-button>
        </template>
        <!-- 操作 -->
        <template v-slot:action="{row}">

          <el-link
            type="primary"
            :underline="false"
            icon="el-icon-edit"
            @click="handleAddOrEdit(row,'update')">
            修改
          </el-link>
          <el-popconfirm
            class="ele-action"
            title="确定要删除此信息吗？"
            @confirm="remove([row.id])"
          >
            <template v-slot:reference>
              <el-link
                type="danger"
                :underline="false"
                icon="el-icon-delete"
              >
                删除
              </el-link>
            </template>
          </el-popconfirm>
        </template>
        <template v-slot:applyUserName="{row}">
          <el-link
            type="primary"
            :underline="false"
            @click="handleDetail(row,'view')"
          >
            {{ row.applyUserName }}
          </el-link>
        </template>
      </ele-pro-table>
    </el-card>

    <!-- 多选删除弹窗 -->
    <pop-modal
      :visible.sync="delVisible"
      content="是否确定删除？"
      @done="commitBtn"/>
    <add-or-edit-dialog :add-or-edit-dialog-flag.sync="addOrEditDialogFlag" ref="addOrEditDialogRef"
                        v-if="addOrEditDialogFlag" @reload="reload"></add-or-edit-dialog>

  </div>
</template>

<script>
import popModal from '@/components/pop-modal';
import dictMixins from "@/mixins/dictMixins";
import addOrEditDialog from "./components/addOrEditDialog.vue";
import searchTable from "./components/searchTable.vue";
import {
  settlementAccountPageListAPI,
  settlementAccountRemoveAPI,
  settlementAccountSubmit
} from "@/api/financialManage/settlementAccount";

export default {
  mixins: [dictMixins],
  components: {
    popModal,
    addOrEditDialog,
    searchTable
  },
  data() {
    return {
      // 加载状态
      loading: false,
      delVisible: false,
      addOrEditDialogFlag: false,
      selection: [],
    };
  },
  computed: {
    columns() {
      return [
        {
          width: 45,
          type: 'selection',
          columnKey: 'selection',
          align: 'center'
        },
        {
          width: 60,
          label: '序号',
          type: 'index',
          columnKey: 'index',
          align: 'center',
        },
        {
          minWidth: 80,
          prop: 'type',
          label: '类型',
          slot: 'type',
          align: 'center',
          showOverflowTooltip: true,
          formatter: (row, column) => {
            return row.type == 1 ? '现金' : '银行卡';
          }
        },
        {
          minWidth: 200,
          prop: 'account',
          label: '银行账户',
          align: 'center',
          slot: 'account',
          showOverflowTooltip: true
        },
        {
          minWidth: 200,
          prop: 'bankName',
          label: '银行名称',
          slot: 'bankName',
          align: 'center',
          showOverflowTooltip: true
        },
        {
          minWidth: 200,
          prop: 'branchName',
          label: '开户行名称',
          slot: 'branchName',
          align: 'center',
          showOverflowTooltip: true
        },

        {
          minWidth: 80,
          prop: 'enabled',
          label: '是否启用',
          align: 'center',
          slot: 'modelType',
          showOverflowTooltip: true,
          formatter: (row, column) => {
            return row.enabled ? '启用' : '禁用';
          }
        },
        {
          minWidth: 100,
          prop: 'createTime',
          label: '创建时间',
          align: 'center',
          slot: 'createTime',
          showOverflowTooltip: true
        },
        {
          columnKey: 'action',
          label: '操作',
          width: 120,
          align: 'center',
          resizable: false,
          slot: 'action',
          showOverflowTooltip: true,
          fixed: 'right'
        }
      ]
    }
  },
  created() {
  },
  methods: {
    //新增、修改
    handleAddOrEdit(row = {}, type) {
      this.addOrEditDialogFlag = true
      this.$nextTick(() => {
        this.$refs.addOrEditDialogRef.init(row, type)
      })
    },
    //新增、修改
    handleDetail(row = {}, type) {
      this.detailDialogFlag = true
      this.$nextTick(() => {
        this.$refs.detailDialogRef.init(row, type)
      })
    },


    /* 表格数据源 */
    datasource({page, limit, where, order}) {
      return settlementAccountPageListAPI({
        pageNum: page,
        size: limit,
        ...where
      });
    },

    /* 刷新表格 */
    reload(where={}) {
      console.log(1111);
      this.$refs.table.reload({page: 1, where});
    },

    //批量删除
    allDelBtn() {
      if (this.selection.length === 0) return;
      let flag = this.selection.some(item => [1, 2].includes(item.approvalStatus))
      if (flag) return this.$message.warning('抱歉已审核、审核中的数据不能删除,请检查')
      this.delVisible = true;
    },

    commitBtn() {
      const dataId = this.selection.map((v) => v.id);
      settlementAccountRemoveAPI(dataId).then((res) => {
        this.$message.success('删除成功！');
        this.reload();
      });
    },
    remove(row) {
      settlementAccountRemoveAPI(row).then((res) => {
        this.$message.success('删除成功！');
        this.reload();
      });
    },

    sub(res) {
      settlementAccountSubmit({
        businessId: res.id
      })
        .then((res) => {
          this.$message.success('提交成功');
          this.reload();
        })
        .catch((e) => {
          this.$message.error(e.message);
        });
    },
  }
};
</script>

<style lang="scss" scoped>
:deep(.el-link--inner) {
  margin-left: 0px !important;
}

.sys-organization-list {
  height: calc(100vh - 264px);
  box-sizing: border-box;
  border-width: 1px;
  border-style: solid;
  overflow: auto;
}

.sys-organization-list :deep(.el-tree-node__content) {
  height: 40px;

  & > .el-tree-node__expand-icon {
    margin-left: 10px;
  }
}
</style>
